<template>
	<v-container class="field-show flex-grow-1" :class="{ 'pb-0 px-0': $vuetify.breakpoint.smAndDown }">
		<v-form v-model="isFormValid" @submit.prevent="handleSubmit">
			<v-card class="pt">
				<v-card-text class="form-content">
					<v-alert v-if="!isLoading && error" type="error" class="ma-4 mb-4 d-flex justify-center">
						{{ error }}
					</v-alert>
					<v-text-field
						label="Email"
						autofocus
						v-model="email"
						:rules="[
							isNotEmpty('Please enter the email address of the member'),
							isValidEmailAddress('Please enter a valid email address'),
						]"
						validate-on-blur
						class="mt-4"
					/>
				</v-card-text>

				<v-card-actions class="px-4 pb-5 d-flex flex-wrap justify-end">
					<v-btn type="button" class="px-4" @click="handleCancel" link depressed rounded>Cancel</v-btn>
					<v-btn type="submit" :loading="isLoading" class="px-4" color="primary" depressed rounded>Add Member</v-btn>
				</v-card-actions>
			</v-card>
		</v-form>
	</v-container>
</template>

<script lang="ts">
import { computed, defineComponent, onUnmounted, ref } from '@vue/composition-api';
import soilApiService from '@/services/soilApiService';
import { isNotEmpty, isValidEmailAddress } from '@/utils/rules';

export default defineComponent({
	components: {},
	props: {
		groupId: { type: String, required: true },
	},
	setup(props, { root }) {
		const isFormValid = ref<boolean>(false);
		const email = ref<string>('');
		const createError = ref();
		const isLoading = ref(false);
		const error = computed<string>(() =>
			createError.value ? 'An error occurred while attempting to create the membership.' : ''
		);

		const handleSubmit = async () => {
			if (!isFormValid.value) {
				return;
			}

			try {
				isLoading.value = true;
				await soilApiService.createMembership({ groupId: props.groupId, userEmail: email.value });
				root.$router.push(`/groups/${props.groupId}`);
			} catch (err) {
				createError.value = err;
			} finally {
				isLoading.value = false;
			}
		};

		const handleCancel = async () => {
			root.$router.push(`/groups/${props.groupId ? props.groupId : ''}`);
		};

		onUnmounted(() => {
			root.$store.dispatch('memberships/getMemberships', props.groupId);
		});

		return {
			isFormValid,
			email,
			isLoading,
			error,
			handleSubmit,
			handleCancel,
			isValidEmailAddress,
			isNotEmpty,
		};
	},
});
</script>
